# -*- coding: gbk -*- 

import wx
import MainFrame
#import LLC 
import os
import pickle as pick
import numpy as np
import matplotlib
from matplotlib.backends.backend_wxagg import FigureCanvasWxAgg as FigureCanvas
from matplotlib.backends.backend_wxagg import NavigationToolbar2WxAgg as NavigationToolbar

PI = np.pi
#--------------------------------------------------------------
ver = '0.0.1'
build = '2011-9-25'
#--------------------------------------------------------------

class MainFrameLLC_Frame(MainFrame.LLC_Frame):
	def __init__(self, parent):
		MainFrame.LLC_Frame.__init__(self, parent )
		self.icon = wx.Icon('.\icon\llcwin.ico', wx.BITMAP_TYPE_ICO)
		self.SetIcon(self.icon)  
		self.FileName = ''
		self.figure = matplotlib.figure.Figure(figsize=(5,4))
		self.axes = self.figure.add_subplot(111)
		self.canvas = FigureCanvas(self.m_panel3,-1,self.figure)
		self.navtoolbar = NavigationToolbar(self.canvas)
		self.axes.set_xlabel('Switch Frequency(KHz)')
		self.axes.set_ylabel('Gain')
		self.axes.set_title('$\lambda=L_{r}/L_{m} \ , \ Q=({\pi}^2 \cdot \sqrt{L_{r}/C_{r}})/(8 \cdot R_{E})$')
		mySizer = wx.BoxSizer(wx.VERTICAL )
		mySizer.Add(self.canvas, 1, wx.LEFT | wx.TOP | wx.GROW)
		mySizer.Add(self.navtoolbar, 0, wx.EXPAND)
		self.m_panel3.SetSizer(mySizer)
		self.m_panel3.Layout()
		mySizer.Fit(self.m_panel3 )
		
	#-----------------------------------------------------------
	def CalcNpRE( self):
		try:
			
			self.Pout = float(self.txtPout.Value)
			self.Efficient = float(self.txtEfficiency.Value)
			self.Pin = self.Pout/self.Efficient
			va = float(self.txtVAin.Value)
			tt=self.rbInputType.Selection
			if tt == 0:
				self.RE = va*va/self.Pin 	#Ч
			else:
				self.RE = self.Pin/va/va
			
			va = float(self.txtVAout.Value)
			tt=self.rbOutputType.Selection
			if tt == 0:
				self.RL = va*va/self.Pout #ʵʸ
			else:
				self.RL = self.Pout/va/va
			
			self.Np = np.sqrt(self.RE/8/self.RL)*PI
			return True
		except Exception as ex:
			dlg=wx.MessageDialog(None,"̳!\r"+str(ex),\
							"",wx.OK|wx.ICON_ERROR)
			dlg.ShowModal()
			dlg.Destroy()
			return False
	#-----------------------------------------------------------
	def OnCalcMid( self, event ):
		if self.CalcNpRE():
			self.txtRE.SetValue('%1.3f'%(self.RE))
			self.txtNp.SetValue('%1.4f'%(self.Np))
			self.txtRL.SetValue('%1.3f'%(self.RL))
			self.txtNp.SetToolTipString('Ns = %1.4f'%(1/self.Np))
	#-----------------------------------------------------------
	def OnOpenFile(self,event):
		wildcard = 	u"ļ (*.cfg)|*.cfg|ļ (*.*)|*.*"
		dialog = wx.FileDialog(None, u"ļ", os.getcwd(), "", wildcard, wx.OPEN)
		
		if dialog.ShowModal() == wx.ID_OK:
			self.FileName = dialog.GetPath() 
			try:
				f = open(self.FileName,'rb')
				Config = pick.load(f)
				f.close()
				if len(Config) == 11:
					self.rbInputType.SetSelection(Config[0])
					self.txtVAin.SetValue(Config[1])
					self.txtPout.SetValue(Config[2])
					self.txtVAout.SetValue(Config[3])
					self.rbOutputType.SetSelection(Config[4])
					self.txtLm.SetValue(Config[5])
					self.txtLr.SetValue(Config[6])
					self.txtCr.SetValue(Config[7])
					self.txtEfficiency.SetValue(Config[8])
					self.txtMaxGain.SetValue(Config[9])
					self.txtMinGain.SetValue(Config[10])
			except Exception as ex:
				dlg=wx.MessageDialog(None,"ȡļ!\r"+str(ex),
								"",wx.OK|wx.ICON_ERROR)
				dlg.ShowModal()
				dlg.Destroy()
		dialog.Destroy()
	#-----------------------------------------------------------
	def OnSaveAsFile(self,event):
		wildcard = 	u"ļ (*.cfg)|*.cfg|ļ (*.*)|*.*"
		dialog = wx.FileDialog(None, u"ļ", os.getcwd(), "", wildcard, wx.SAVE)
		if dialog.ShowModal() == wx.ID_OK:
			self.FileName = dialog.GetPath() 
			try:
				Config = []
				Config.append(self.rbInputType.Selection)
				Config.append(self.txtVAin.Value)
				Config.append(self.txtPout.Value)
				Config.append(self.txtVAout.Value)
				Config.append(self.rbOutputType.Selection)
				Config.append(self.txtLm.Value)
				Config.append(self.txtLr.Value)
				Config.append(self.txtCr.Value)
				Config.append(self.txtEfficiency.Value)
				Config.append(self.txtMaxGain.Value)
				Config.append(self.txtMinGain.Value)
				f = open(self.FileName, 'wb')
				pick.dump(Config, f) 
				f.close()
			except Exception as ex:
				dlg=wx.MessageDialog(None,"ļ!\r"+str(ex),
								"",wx.OK|wx.ICON_ERROR)
				dlg.ShowModal()
				dlg.Destroy()
		dialog.Destroy()
	#-----------------------------------------------------------
	def OnAbout(self,event):
		dlg=wx.MessageDialog(None,"LLCwin:LLC㹤\n汾:%s\nʱ:%s\nwang.zr97@gmail.com"%(ver,build),
							"",wx.OK|wx.ICON_INFORMATION)
		dlg.ShowModal()
		dlg.Destroy()
	#-----------------------------------------------------------
	def OnSaveFile(self,event):
		if self.FileName =='':
			wildcard = 	u"ļ (*.cfg)|*.cfg|ļ (*.*)|*.*"
			dialog = wx.FileDialog(None, u"ļ", os.getcwd(), "", wildcard, wx.SAVE)
			if dialog.ShowModal()== wx.ID_OK :
				self.FileName = dialog.GetPath() 
				dialog.Destroy()
			else:
				dialog.Destroy()
				return
		try:
			Config = []
			Config.append(self.rbInputType.Selection)
			Config.append(self.txtVAin.Value)
			Config.append(self.txtPout.Value)
			Config.append(self.txtVAout.Value)
			Config.append(self.rbOutputType.Selection)
			Config.append(self.txtLm.Value)
			Config.append(self.txtLr.Value)
			Config.append(self.txtCr.Value)
			Config.append(self.txtEfficiency.Value)
			Config.append(self.txtMaxGain.Value)
			Config.append(self.txtMinGain.Value)
			f = open(self.FileName, 'wb')
			pick.dump(Config, f) 
			f.close()
		except Exception as ex:
			dlg=wx.MessageDialog(None,"ļ!\r"+str(ex),
							"",wx.OK|wx.ICON_ERROR)
			dlg.ShowModal()
			dlg.Destroy()
	#-----------------------------------------------------------
	def OnDraw( self, event ):
		if self.CalcNpRE():
			try:
				Lr = float(self.txtLr.Value)
				Lm = float(self.txtLm.Value)
				Cr = float(self.txtCr.Value)
				Fr2 = 1000000/(2*PI*(np.sqrt(Lr*Cr)))
				Fsw=np.linspace(1000,4*Fr2,1000)
				JW = 1j*2*PI*Fsw
				tmp = (JW*Lm*self.RE)/(JW*Lm+self.RE*1000000)
				Gv = np.abs(tmp/(tmp+1000000/(JW*Cr)+JW*Lr/1000000))
				lam = Lr/Lm
				Q = PI*PI*np.sqrt(Lr/Cr)/self.RE/8
				self.axes.plot(Fsw/1000,Gv,label="$\lambda=%1.2f,Q=%1.4f,  fr=%6.2fKHz$"%(lam,Q,Fr2/1000))
				
				LineFrY=np.linspace(0,1.2*np.max(Gv),1000)	#гƵֱ
				LineFrX=np.linspace(Fr2/1000,Fr2/1000,1000)
				self.axes.plot(LineFrX,LineFrY)
				
				MaxGain = float(self.txtMaxGain.Value)
				LineMaxX=np.linspace(0,4*Fr2/1000,1000)	#ֱֵ
				LineMaxY=np.linspace(MaxGain,MaxGain,1000)
				self.axes.plot(LineMaxX,LineMaxY)
				
				MinGain = float(self.txtMinGain.Value)
				LineMinX=np.linspace(0,4*Fr2/1000,1000)	#Сֱֵ
				LineMinY=np.linspace(MinGain,MinGain,1000)
				self.axes.plot(LineMinX,LineMinY)
				
				# diff = np.linspace(0,1,1000)
				# diff[0]=0
				# for i in range(1,1000):
					# diff[i]=Gv[i]-Gv[i-1]
				# self.axes.plot(Fsw/1000,diff)
				
				self.axes.legend()
				self.canvas.draw()
			except Exception as ex:
				dlg=wx.MessageDialog(None,"ͼƬʱ!ǲд\r"+str(ex),
								"",wx.OK|wx.ICON_ERROR)
				dlg.ShowModal()
				dlg.Destroy()
	#-----------------------------------------------------------
	def OnClear(self,event):
		self.figure.set_canvas(self.canvas)
		self.axes.clear()
		self.axes.grid(self.ckGrid.Value)
		self.axes.set_xlabel('Switch Frequency(KHz)')
		self.axes.set_ylabel('Gain')
		self.axes.set_title('$\lambda=L_{r}/L_{m} \ , \ Q=({\pi}^2 \cdot \sqrt{L_{r}/C_{r}})/(8 \cdot R_{E})$')
		self.canvas.draw()
	#-----------------------------------------------------------
	def OnGrid(self,event):
		self.axes.grid(self.ckGrid.Value)
		self.canvas.draw()
	#-----------------------------------------------------------
	def OnCalcGain(self,event):
		if not self.CalcNpRE():
			return
		try:
			freq = float(self.txtFreq.Value)*1000
			Lr = float(self.txtLr.Value)
			Lm = float(self.txtLm.Value)
			Cr = float(self.txtCr.Value)
			JW = 1j*2*PI*freq
			tmp = (JW*Lm*self.RE)/(JW*Lm+self.RE*1000000)
			Gain = np.abs(tmp/(tmp+1000000/(JW*Cr)+JW*Lr/1000000))
			self.txtGain.SetValue('%1.4f'%(Gain))
		except Exception as ex:
			dlg=wx.MessageDialog(None,"ʱ!\r"+str(ex),
							"",wx.OK|wx.ICON_ERROR)
			dlg.ShowModal()
			dlg.Destroy()
#-----------------------------------------------------------
class App(wx.App):	
	def OnInit(self):
		frame = MainFrameLLC_Frame(None)
		#self.SetTopWindow(frame)
		frame.Show()
		return True

#-----------------------------------------------------------
if __name__ == '__main__':
	app = App(0)
	app.MainLoop()